-- B64201A.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained 
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making 
--     this public release, the Government intends to confer upon all 
--     recipients unlimited rights  equal to those held by the Government.  
--     These rights include rights to use, duplicate, release or disclose the 
--     released technical data and computer software in whole or in part, in 
--     any manner and for any purpose whatsoever, and to have or permit others 
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED 
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE 
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- CHECK THAT AGGREGATES ARE NOT ALLOWED IN DEFAULT EXPRESSIONS
-- FOR IN PARAMETERS OF A LIMITED TYPE, INCLUDING:
--    (A) LIMITED PRIVATE TYPES, AND
--    (B) TASK TYPES OR COMPOSITE TYPES HAVING AT LEAST ONE SUBCOMPONENT
--        OF A TASK TYPE. 

-- INITIALIZATION IS OTHERWISE ALLOWED FOR SUCH TYPES.


-- CVP 5/14/81
-- JBG 6/9/83
-- BHS 7/03/84

PROCEDURE B64201A IS
BEGIN

     DECLARE  -- (A)
          PACKAGE PKG IS

               TYPE LPTYPE IS LIMITED PRIVATE;
               CLP  : CONSTANT LPTYPE;

          PRIVATE

               TYPE LPTYPE IS NEW INTEGER RANGE 0..127;
               CLP  : CONSTANT LPTYPE := 127;
          END PKG;

          USE PKG;
     
          TYPE RECTYPE IS
               RECORD
                    F : LPTYPE;
               END RECORD;

          TYPE ATYPE IS ARRAY (1..2) OF LPTYPE;

          PROCEDURE P1 (X : IN LPTYPE := 7) IS      -- ERROR: 7.
          BEGIN
               NULL;
          END P1;

          PROCEDURE P2 (X : IN LPTYPE := CLP) IS    -- OK.
          BEGIN
               NULL;
          END P2;

          PROCEDURE P3 (A : ATYPE := (CLP,CLP)) IS  -- ERROR: (CLP,CLP)
          BEGIN
               NULL;
          END P3;

          PROCEDURE P4 (R : RECTYPE := (F=>CLP)) IS -- ERROR: (F=>CLP)
          BEGIN
               NULL;
          END P4;

     BEGIN  -- (A)

          NULL;

     END;   -- (A)



     DECLARE  -- (B)
          TASK TYPE T_TYPE;
     
          TYPE R1_TYPE IS
               RECORD
                    TT : T_TYPE;
               END RECORD;

          TYPE R2_TYPE IS
               RECORD
                    RR : R1_TYPE;
               END RECORD;

          TYPE AT_TYPE IS ARRAY (1 .. 2) OF T_TYPE;
          TYPE AR_TYPE IS ARRAY (1 .. 2) OF R1_TYPE;

          T1 : T_TYPE;
          R1 : R1_TYPE;
          AR1 : AR_TYPE;

          TASK BODY T_TYPE IS
          BEGIN
               NULL;
          END T_TYPE;

          PROCEDURE P1 (TX : T_TYPE := T1) IS           -- OK.
          BEGIN
               NULL;
          END P1;

          PROCEDURE P2 (R1X : R1_TYPE := R1) IS         -- OK.
          BEGIN
               NULL;
          END P2;

          PROCEDURE P3 (R2X : R2_TYPE := (RR=>R1)) IS  -- ERROR: 
                                                       -- (RR=>R1)
          BEGIN
               NULL;
          END P3;

          PROCEDURE P4 (ATX : AT_TYPE := (T1, T1)) IS   -- ERROR: 
                                                        -- (T1, T1)
          BEGIN
               NULL;
          END P4;

          PROCEDURE P5 (ARX : AR_TYPE := (R1, R1)) IS   -- ERROR:
                                                        --  (R1, R1)
          BEGIN
               NULL;
          END P5;

          FUNCTION F6 (ATR : AR_TYPE := AR1)             -- OK.
                      RETURN INTEGER IS
          BEGIN
               RETURN 1;
          END F6;


     BEGIN  -- (B)

          NULL;

     END;   -- (B)


END B64201A;
